﻿Option Strict On
Imports Microsoft.Phone.Tasks
Imports System.Windows.Media.Imaging
Imports Microsoft.Phone
Imports ImageTools
Imports ImageTools.Filtering
Imports System.IO.IsolatedStorage
Imports Microsoft.Xna.Framework.Media
Imports System.IO
'Imports Microsoft.Expression.Interactivity.Layout
Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub
    Dim myCameraTask As CameraCaptureTask
    Dim loadImage As ExtendedImage
    Dim filterImage As ExtendedImage
    Dim myImage As BitmapImage

    Dim myContextMenu As New ContextMenu
    Dim myMenuItem1 As New MenuItem
    Dim menuItemList As New List(Of MenuItem)
    Dim imageControl As UIElement
    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        myCameraTask = New CameraCaptureTask
        AddHandler myCameraTask.Completed, Sub(resultSender As Object, resultArgs As PhotoResult)
                                               If resultArgs.TaskResult = TaskResult.OK Then

                                                   myImage = New BitmapImage
                                                   myImage.SetSource(resultArgs.ChosenPhoto)
                                                   Image1.Source = myImage
                                                   Image2.Source = myImage
                                                   Image3.Source = myImage
                                                   Image4.Source = myImage

                                                   Image5.Source = myImage

                                                   Dim wb As WriteableBitmap = New WriteableBitmap(myImage)
                                                   loadImage = New ExtendedImage
                                                   loadImage.SetPixels(myImage.PixelWidth, myImage.PixelHeight, wb.ToByteArray())

                                                   Dim filter As Sepia
                                                   filter = New Sepia
                                                   filterImage = New ExtendedImage(loadImage)
                                                   filter.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
                                                   Dim bitmap = filterImage.ToBitmap
                                                   Image1.Source = bitmap

                                                   Dim filter2 As Inverter
                                                   filter2 = New Inverter
                                                   filterImage = New ExtendedImage(loadImage)
                                                   filter2.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
                                                   Dim bitmap2 = filterImage.ToBitmap
                                                   Image2.Source = bitmap2

                                                   Dim filter3 As Grayscale
                                                   filter3 = New GrayscaleRMY
                                                   filterImage = New ExtendedImage(loadImage)
                                                   filter3.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
                                                   Dim bitmap3 = filterImage.ToBitmap
                                                   Image3.Source = bitmap3

                                                   Dim filter4 As Brightness
                                                   filter4 = New Brightness(50)
                                                   filterImage = New ExtendedImage(loadImage)
                                                   filter4.Apply(filterImage, loadImage, New ImageTools.Rectangle(0, 0, loadImage.PixelWidth, loadImage.PixelHeight))
                                                   Dim bitmap4 = filterImage.ToBitmap
                                                   Image4.Source = bitmap4

                                                   AddHandler Image5.Hold, Sub(imageSender As Object, imageArgs As System.Windows.Input.GestureEventArgs)
                                                                               myMenuItem1.Header = "各種イメージフィルタ"
                                                                               menuItemList.Add(myMenuItem1)
                                                                               myContextMenu.ItemsSource = menuItemList
                                                                               myContextMenu.Opacity = 0.7
                                                                               ContextMenuService.SetContextMenu(Image5, myContextMenu)
                                                                               myContextMenu.IsOpen = True
                                                                           End Sub

                                                   AddHandler myMenuItem1.Click, AddressOf myMenuItem_Click
                                               Else
                                                   Exit Sub
                                               End If
                                           End Sub
        MyBase.OnNavigatedTo(e)
    End Sub


    Private Sub Button1_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles Button1.Click
        Select Case Button1.Content.ToString
            Case "カメラ起動"
                myCameraTask.Show()
            Case "元に戻す"
                Image5.Visibility = Windows.Visibility.Visible
                Image1.Visibility = Windows.Visibility.Collapsed
                Image2.Visibility = Windows.Visibility.Collapsed
                Image3.Visibility = Windows.Visibility.Collapsed
                Image4.Visibility = Windows.Visibility.Collapsed
                Button1.Content = "カメラ起動"
        End Select

    End Sub

    Private Sub myMenuItem_Click(sender As Object, e As EventArgs)

        Dim selectHeader = DirectCast(sender, MenuItem).Header
        Select Case selectHeader.ToString
            Case "各種イメージフィルタ"
                Image5.Visibility = Windows.Visibility.Collapsed
                Image1.Visibility = Windows.Visibility.Visible
                Image2.Visibility = Windows.Visibility.Visible
                Image3.Visibility = Windows.Visibility.Visible
                Image4.Visibility = Windows.Visibility.Visible
                Button1.Content = "元に戻す"
            Case Else
                Image5.Visibility = Windows.Visibility.Visible
                Exit Sub
        End Select
    End Sub

    Private Sub Image1_Hold(sender As Object, e As System.Windows.Input.GestureEventArgs) Handles Image1.Hold
        contextMenuShow(Image1)
    End Sub

    Private Sub Image2_Hold(sender As Object, e As System.Windows.Input.GestureEventArgs) Handles Image2.Hold
        contextMenuShow(Image2)
    End Sub

    Private Sub Image3_Hold(sender As Object, e As System.Windows.Input.GestureEventArgs) Handles Image3.Hold
        contextMenuShow(Image3)
    End Sub

    Private Sub Image4_Hold(sender As Object, e As System.Windows.Input.GestureEventArgs) Handles Image4.Hold
        contextMenuShow(Image4)
    End Sub

    Private Sub contextMenuShow(myControl As UIElement)
        imageControl = myControl
        Dim myMenuItem As New MenuItem
        Dim myMenuItemList As New List(Of MenuItem)
        Dim _myContextMenu As New ContextMenu
        myMenuItem.Header = "PicturesHUBに保存"
        myMenuItemList.Add(myMenuItem)
        _myContextMenu.ItemsSource = myMenuItemList
        _myContextMenu.Opacity = 0.7
        ContextMenuService.SetContextMenu(myControl, _myContextMenu)
        _myContextMenu.IsOpen = True

        AddHandler myMenuItem.Click, AddressOf _myMenuItem_Click
    End Sub

    Private Sub _myMenuItem_Click(sender As Object, e As EventArgs)

        Dim selectHeader = DirectCast(sender, MenuItem).Header
        Select Case selectHeader.ToString
            Case "PicturesHUBに保存"
                Dim imageFileName As String = DateTime.Now.ToString("yyyyMMddHHmmss") & ".jpg"
                Dim myWriteableBitmap As WriteableBitmap
                myWriteableBitmap = New WriteableBitmap(imageControl, Nothing)

                Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
                If storage.FileExists(imageFileName) = True Then
                    storage.DeleteFile(imageFileName)
                End If
                Using myStream As IsolatedStorageFileStream = storage.CreateFile(imageFileName)
                    System.Windows.Media.Imaging.Extensions.SaveJpeg(myWriteableBitmap, myStream, myWriteableBitmap.PixelWidth, myWriteableBitmap.PixelHeight, 0, 85)
                End Using

                Dim myLibray As New MediaLibrary
                Using Stream As IsolatedStorageFileStream = storage.OpenFile(imageFileName, FileMode.Open, FileAccess.Read)
                    myLibray.SavePicture(imageFileName, Stream)
                    MessageBox.Show("PicturesHubに保存しました。")
                End Using
            Case Else
                Exit Sub
        End Select
    End Sub

   
End Class
